indexing
   title:       "presents an example of LONG_DURATION class usage";
   cluster:     "timedate/examples/test_ldr [timedate/examples/test_ldr]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_ldr.e";

class TEST_LONG_DURATION

   inherit
      IO_USER

   creation
      make

   feature

      ld1, ld2, ld3 : LONG_DURATION


      test_long_duration is

         do
            put_nl ("Initialize long_duration -------------");
            !! ld1.set_date(1995, 1, 10);
            !! ld2.set_days( + 100  ); -- hundred days
            !! ld3.set_days( - 100  ); -- minus 100 days

            put_nl (x.s_long_duration (ld1)); -- print variable
            put_nl (x.s_long_duration (ld2));
            put_nl (x.s_long_duration (ld3));

            -- hundred days later
            put_nl (x.s_long_duration (ld1 + ld2));
            -- hundred days before
            put_nl (x.s_long_duration (ld1 + ld3));

            -- compare the two dates
            mio.put_boolean (ld1.plus (ld2) < ld2 + ld3);
            mio.put_new_line; mio.put_new_line;

            put_nl ("Some magic calculation with long_duration ----");
            ld3 := ld2.multiply_by (10);
            put_nl (x.s_long_duration (ld3)); -- should be 1000 days
            mio.put_real ( ld3.as_years); put_nl (" as years");
            mio.put_real ( ld3.as_months); put_nl (" as months");
            mio.put_real ( ld3.as_days); put_nl (" as days");

            ld2 :=  ld1.plus( ld3.multiply_by( 10 ) );
            put_nl (x.s_long_duration (ld2));  -- 1000 days after 1995,1,10
            mio.put_new_line
         end -- test_long_duration

      test_two_duration (days1, days2 : INTEGER) is

         do
            !! ld1.set_days (days1);
            !! ld2.set_days (days2);
            put_nl (x.s_long_duration (ld1)); -- print variable
            put_nl (x.s_long_duration (ld2));
            put_nl (x.s_long_duration (ld1+ld2));

            if ld1 < ld2 then
               ld3 := ld2 - ld1;
            else
               ld3 := ld1 - ld2;
            end -- if

            put_nl (x.s_long_duration (ld3));
            mio.put_real ( ld1.ratio (ld2)); put_nl (" ld1 ratio ld2 ");
            mio.put_real ( ld2.ratio (ld1)); put_nl (" ld2 ratio ld1 ");
         end -- test_two_duration

      make is

         do
            test_long_duration;
            test_two_duration (1000, 10000);
            test_two_duration (-999, 333);
            test_two_duration (-25, -25);
         end -- make

   end --  class TEST_LONG_DURATION

